% mytic
%   Start timer
%     do_reset - resets global tictoc counter
%
function mytic(do_reset)

    if nargin<1;  do_reset = 0;  end;
    
    is_multithreading = (matlabpool('size')>0);
    
    if ~is_multithreading
        
        global gtictoc_cnt gtictoc_times;

        if strcmp(do_reset,'reset') || do_reset==1;  gtictoc_cnt = [];  gtictoc_times = [];  return;  end;

        % Increase tictoc counter
        if isempty(gtictoc_cnt);  gtictoc_cnt = 0;  end;
        gtictoc_cnt = gtictoc_cnt + 1;

        %tic;
        gtictoc_times(gtictoc_cnt) = cputime;
    
    else
        
        % Do not overwrite global variable, instead create new ones that
        % has their scope within each parfor only
        
        global g_mt_tictoc_cnt g_mt_tictoc_times;

        if strcmp(do_reset,'reset') || do_reset==1;  g_mt_tictoc_cnt = [];  g_mt_tictoc_times = [];  return;  end;

        % Increase tictoc counter
        if isempty(g_mt_tictoc_cnt);  g_mt_tictoc_cnt = 0;  end;
        g_mt_tictoc_cnt = g_mt_tictoc_cnt + 1;

        %tic;
        g_mt_tictoc_times(g_mt_tictoc_cnt) = cputime;
        
    end
end
