% mytoc
%   Stop timer and display elapsed time (set global variable : do_verbose)
%   t - Elapsed time;
%
function t = mytoc(string)

    if nargin<1;  string = getcallersname;  end;
    
    is_multithreading = (matlabpool('size')>0);
    
    if ~is_multithreading
        
        %t = toc;
        global gtictoc_cnt gtictoc_times;
        if isempty(gtictoc_cnt);  warning('No mytic() called previously'); return;  end;
        t = cputime;
        dt = t - gtictoc_times(gtictoc_cnt);

        if do_verbose
            prestring = '';
            if gtictoc_cnt>1;  prestring = [num2str(gtictoc_cnt-1) '-'];  end;
            disp(['*** ' prestring 'Elapsed ' string ': ' num2str(dt) ' sec.']);
        end

        % Decrease tictoc counter
        gtictoc_cnt = gtictoc_cnt - 1;
        if gtictoc_cnt<1;  gtictoc_cnt=[]; gtictoc_times = [];  end;

    else
        
        
        % Do not overwrite global variable, instead create new ones that
        % has their scope within each parfor only
        
        %t = toc;
        global g_mt_tictoc_cnt g_mt_tictoc_times;
        if isempty(g_mt_tictoc_cnt);  warning('No mytic() called previously'); return;  end;
        t = cputime;
        dt = t - g_mt_tictoc_times(g_mt_tictoc_cnt);

        if do_verbose
            prestring = '';
            if g_mt_tictoc_cnt>1;  prestring = [num2str(g_mt_tictoc_cnt-1) '-'];  end;
            disp(['*** (parfoor) ' prestring 'Elapsed ' string ': ' num2str(dt) ' sec.']);
        end

        % Decrease tictoc counter
        g_mt_tictoc_cnt = g_mt_tictoc_cnt - 1;
        if g_mt_tictoc_cnt<1;  g_mt_tictoc_cnt=[]; g_mt_tictoc_times = [];  end;
    
    end
        
end

function s = getcallersname

    st = dbstack;
    if size(st,1)>2;  s = st(3).name;
    else              s = '';          end;

end
