% [U1,U2] = separatespectrum(U,n1,n2)
%    Separate eigenvectors from connectivity graph eigenvectors
%      U - eigenvectors of connectivity graph ((n1+n2) x k)
%      n1 - number of nodes in mesh 1
%      n2 - number of nodes in mesh 2
%
function [U1,U2] = separatespectrum(U,n1,n2)

   % Eigenvectors for each mesh
   U1 = U(1:n1,:);
   U2 = U((1:n2) + n1,:);

end
