% Show deformation strength between two meshes
%
function [S1,S2] = showdeformation(X1,F1,X2,F2,corr12,corr21)

    % Deformation strength of mesh
    S1 = sqrt(sum((X2(corr12,:) - X1).^2,2)); % magnitude of deformation
    S2 = sqrt(sum((X1(corr21,:) - X2).^2,2));

    clf;
    colormap jet;
    lim = [X1;X2]; lim = [min(lim(:,1)) max(lim(:,1)) min(lim(:,2)) max(lim(:,2)) min(lim(:,3)) max(lim(:,3))];
    
    % Deformatin of mesh 1
    h(1) = subplot(1,2,1);
    trisurf(F1,X1(:,1),X1(:,2),X1(:,3),S1); shading interp; daspect([1 1 1]); view(90,0); material dull; axis(lim); camlight;
    colorbar;

    % Deformatin of mesh 2
    h(2) = subplot(1,2,2);
    trisurf(F2,X2(:,1),X2(:,2),X2(:,3),S2); shading interp; daspect([1 1 1]); view(90,0); material dull; axis(lim); camlight;
    colorbar;
    
    obj = linkprop(h,{'cameraposition','cameraupvector','cameratarget','cameraviewangle'});
    set(gcf,'UserData',obj);
    
end
