% [X1,X2] = warp(X1,X2,scale1,scale2)
%    Warp both functions X1,X2 such that their extremas matches
%    Uses TPS for warping
%      X1     - data 1
%      X2     - data 2
%      scale1 - update factor for X1 (0: no update, 1: warped to X2, default: 0.5);
%      scale2 - update factor for X2 (0: no update, 1: warped to X1, default: 0.5);
%
function [X1,X2] = warpdata(X1,X2,scale1,scale2)

    if nargin<3;  scale1 = 0.5; scale2 = 0.5;  end;
    if nargin<4;  scale2 = scale1;             end;

    mytic;
    
    Y2 = aligneigenmaps(X1,X2);
    Y1 = aligneigenmaps(X2,X1);
    
    dX1 = Y1-X1;
    dX2 = Y2-X2;
    
    X1 = X1 + scale1*dX1;
    X2 = X2 + scale2*dX2;

    mytoc;
    
end
