% [E,w] = weightfeatures(E,w)
%   Linear weight of features (weights are internally normalized)
%     E - features (weighted with w in the output)
%     w - weightes (normalized value in the output)
%
function [E,w] = weightfeatures(E,w)

    if size(w,2)==1; w=w'; end;

    w = w / sum(w);
    E = bsxfun(@times,E,w);

end
